import sys, string
from xml.dom import minidom, Node


# Funkce pro vlozeni slozeneho elementu <polozka>
# <polozka> obsahuje atribut "kod" (code) a vnorene elementy <nazev> a <mnozstvi>
# <nazev> je jednoduchy element obsahujici pouze hodnotu (name)
# <mnozstvi> obsahuje atributy "cena" (price), "jednotka" (unit) a hodnotu (num)
# Parametry funkce:
# 	doc - stromova struktura XML dokumentu
# 	parentNode - rodicovsky uzel, kteremu se vklada potomek
# 	name - hodnota elementu <nazev>
# 	price - hodnota atributu "cena" elementu <mnozstvi>
# 	unit - hodnota atributu "jednotka" elementu <mnozstvi>
# 	num - hodnota elementu <mnozstvi>
def addPolozka(doc, parentNode, code, name, price, unit, num):
	#pomocny TEXT_NODE pro spravne odsazeni elementu
	tmpNode = doc.createTextNode("\n		")
	#vlozeni elementu do seznamu potomku uzlu 'parentNode'
	parentNode.appendChild(tmpNode)
	#vytvoreni noveho elementu s nazvem 'polozka'
	polozka = doc.createElement("polozka")
	#pomocny TEXT_NODE pro spravne odsazeni elementu
	tmpPolozka1 = doc.createTextNode("\n			")
	#vlozeni elementu do seznamu potomku uzlu 'polozka'
	polozka.appendChild(tmpPolozka1)
	#vytvoreni atributu "kod" elementu <polozka> a nastaveni jeho hodnoty
	polozka.setAttribute("kod", code)
	#vytvoreni noveho elementu jmenem 'nazev'
	nazev = doc.createElement("nazev")
	#novy TEXT_NODE obsahujici hodnotu elementu <nazev>
	textNazev = doc.createTextNode(name)
	#vlozeni elementu 'textNazev' do seznamu potomku elementu 'nazev'
	nazev.appendChild(textNazev)
	#vlozeni elementu 'nazev' do seznamu potomku elementu 'polozka'
	polozka.appendChild(nazev)
	#pomocny TEXT_NODE pro spravne odsazeni elementu
	tmpPolozka2 = doc.createTextNode("\n			")
	#vlozeni elementu do seznamu potomku uzlu 'polozka'
	polozka.appendChild(tmpPolozka2)
	#vytvoreni noveho elementu s nazvem 'mnozstvi'
	mnozstvi = doc.createElement("mnozstvi")
	#vytvoreni atributu "cena" elementu <mnozstvi> a nastaveni jeho hodnoty
	mnozstvi.setAttribute("cena", price)
	#vytvoreni atributu "jednotka" elementu <mnozstvi> a nastaveni jeho hodnoty
	mnozstvi.setAttribute("jednotka", unit)
	#novy TEXT_NODE obsahujici hodnotu elementu <mnozstvi>
	textMnozstvi = doc.createTextNode(num)
	#vlozeni elementu 'textMnozstvi' do seznamu potomku elementu 'mnozstvi'
	mnozstvi.appendChild(textMnozstvi)
	#vlozeni elementu 'mnozstvi' do seznamu potomku elementu 'polozka'
	polozka.appendChild(mnozstvi)
	#pomocny TEXT_NODE pro spravne odsazeni elementu
	tmpPolozka3 = doc.createTextNode("\n		")
	#vlozeni elementu do seznamu potomku uzlu 'polozka'
	polozka.appendChild(tmpPolozka3)
	#vlozeni noveho elementu 'polozka' do seznamu potomku rodicovskeho uzlu
	parentNode.appendChild(polozka)

#Funkce pro pruchod stromem vyuzivajici generatory  
def walkTree(node):                                             
	if node.nodeType == Node.ELEMENT_NODE:
		yield node
		for child in node.childNodes:
			for n1 in walkTree(child):
				yield n1

#Funkce pro beh programu, parametr je jmeno XML souboru
def run(inFileName):        
	#standardni vystup                                    
	outFile = sys.stdout
	#parsovani dokumentu a vytvoreni stromove struktury
	doc = minidom.parse(inFileName)
	#nastaveni korene stromu na documentElement
	rootNode = doc.documentElement
	#pruchod stromovou strukturou
	for node in walkTree(rootNode):
		#vlozeni nove polozky do elementu <ovoce>
		if node.nodeName == "ovoce":
			#pomocny TEXT_NODE pro spravne odsazeni elementu
			tmpOvoce1 = doc.createTextNode("	")   
			node.appendChild(tmpOvoce1)
			#volani funkce pro vlozeni nove polozky
			addPolozka(doc, node, "0056", "banany", "25", "kg", "15") 
			#pomocny TEXT_NODE pro spravne odsazeni elementu
			tmpOvoce2 = doc.createTextNode("\n	")
			node.appendChild(tmpOvoce2)  
		#vlozeni novych polozek do elementu <zelenina>                   
		elif node.nodeName == "zelenina":
			#pomocny TEXT_NODE pro spravne odsazeni elementu
			tmpZelenina1 = doc.createTextNode("	")
			node.appendChild(tmpZelenina1)
			#volani funkce pro vlozeni nove polozky
			addPolozka(doc, node, "1090", "kedlubna", "8", "ks", "5")
			addPolozka(doc, node, "1085", "mrkev", "20", "kg", "10")
			tmpZelenina2 = doc.createTextNode("\n	")
			#pomocny TEXT_NODE pro spravne odsazeni elementu
			node.appendChild(tmpZelenina2)
			break
	#tisk stromove struktury
	print doc.toprettyxml(indent = '   ')
	#vytvoreni noveho souboru pro zapis upraveneho XML dokumentu
	file_xml = file("jidlo_new.xml", "w")
	#zapis dat do souboru
	doc.writexml(file_xml)

#funkce pro test poctu vstupnich paramentru
def main():
	args = sys.argv[1:]
	if len(args) != 1:
		print 'Pro spusteni zadejte: python dom_add.py jidlo.xml'
		sys.exit(-1)
	run(args[0])

main()

