"""
DOM zpracovani dokumentu:
Program zjisti jmena vsech druhu ovoce, jenz jsou prodavana na kg.
Data se ctou ze xml dokumentu, ktery je zadan jako parametr v prikazove radce.
Jmena se ukladaji do seznamu a tisknou na standardni vystup.
"""

#import modulu pro praci se vstupem a vystupem, s retezci
import sys, string
#import modulu pro tvorbu stromove struktury a uzlu stromu
from xml.dom import minidom, Node

nameList = []		#seznam jmen
dataList = []		#seznam pro data v elementu <nazev>

#funkce pro beh programu
def run(inFileName):   
	#standardni vystup                                        
	outFile = sys.stdout
	#parsovani dokumentu a vytvoreni stromove struktury
	doc = minidom.parse(inFileName)
	#nastaveni korene stromu na documentElement
	rootNode = doc.documentElement
	#vytvoreni seznamu elenentu <ovoce>
	ovoce = rootNode.getElementsByTagName("ovoce")
	#test zda je jen jeden
	if len(ovoce) == 1:
		#vytvoreni seznamu elenemtu <polozka>
		items = ovoce[0].getElementsByTagName("polozka")
		#pruchod seznamem
		for item in items:
			#pruchod seznamem bezprostrednich nasledovniku elementu <polozka>
			for child in item.childNodes:
				#pokud se jedna o element <nazev>
				if child.nodeName == "nazev":
					#projdi jeho bezprostredni nasledovniky
					for node in child.childNodes:
						#a uzly typu TEXT_NODE vloz do seznamu dataList
						if node.nodeType == Node.TEXT_NODE:
							dataList = []
							dataList.append(node.nodeValue)
				#pokud se jedna o element <monozstvi>
				elif child.nodeName == "mnozstvi":
					attrs = child.attributes
					#najdi ve slovniku atributu atribut jmenem jednotka
					unit = attrs.get("jednotka").nodeValue
					#pokud je hodnota atributu = kg
					if unit == "kg":
						#a pokud neni seznam dataList prazdny
						if dataList:
							#vytvnor retezec z obasahu seznamu dataList
							strName = string.join(dataList)
							#a vloz ho do seznamu nameList
							nameList.append(strName)
	else:
		outFile.write("Ovoce neni objednane!\n")
	printList(outFile, nameList)
	
#Funkce pro tisk seznamu
def printList(outfile, nameList):
	outfile.write("V objednavce jsou %d druhu ovoce:\n" % len(nameList))
	for name in nameList:
		outfile.write(" %s\n" %name)

#funkce pro test poctu vstupnich paramentru
def main():
	args = sys.argv[1:]
	if len(args) != 1:
		print 'Pro spusteni zadejte: python dom_atr.py jidlo.xml'
		sys.exit(-1)
	run(args[0])

main()
