"""
Validace XML dokumentu proti XSD:
Program otevre xml dokument zadany jako prvni parametr prikazove radky a zvalidujeho proti externimu XSD schematu. Jmeno XSD je druhy parametr spousteciho prikazu.
"""

#import modulu pro praci se vstupem a vystupem
import sys
#import modulu pro reprezentaci stromove struktury a validaci XML
from lxml import etree

#Funkce pro beh programu s parametry:
# xmlName - jmeno XML dokumentu
# xsdName - jmeno XSD schematu
def run(xmlName, xsdName):
	#parsovani XML a vytvoreni stromove struktury
	doc = etree.parse(xmlName)
	#otevreni XSD schematu pro cteni
	xsdfile = file(xsdName, "r")
	#parsovani XSD a vytvoreni stromove struktury
	xmlschema_doc = etree.parse(xsdfile)
	#vytvoreni schematu
	xmlschema = etree.XMLSchema(xmlschema_doc)
	#validace, vysledek je bud True nebo False
	if xmlschema.validate(doc) == True:
		print "Dokument '%s' je v poradku." %xmlName
	#reakce na chybu
	else:
		#seznam nalezenych chyb
		log = xmlschema.error_log
		#tisk celeho seznamu
		print log
		error = log.last_error
		#tisk jmena posledni chyby
		print error.type_name
		#tisk posledni chyby
		print error
		#vyhoreni vyjimky s tiskem chyby
		xmlschema.assertValid(doc)

		
#funkce pro test poctu vstupnich paramentru
def main():
	args = sys.argv[1:]
	if len(args) != 2:
		print 'Pro spusteni zadejte: python val_xsd.py jidlo.xml jidlo.xsd'
		sys.exit(-1)
	run(args[0], args[1])

main()
